%% 1) RATE BOUNDS AT OM=0dB
disp('RATE BOUNDS AT OM=0dB')

n = [100:50:350,400:100:2000];
uno = ones(size(n));
Om = 10^(0/10);
Pe = 10^-3;
kappa = 2;
C = rate_AWGN_NA_UB(inf, Om, Pe); tic
% % expected execution time 4.7 sec % <- needs function from SPECTRE
% R_SHA = converse(n, Pe*uno, Om*uno)./n; toc; tic  
% expected execution time 1.5 sec
R_PPV = rate_AWGN_PPV_OnX_UB(n, Om*uno, Pe*uno, kappa); toc; tic
% expected execution time 1.9 sec
R_RCU = rate_AWGN_RCU_On2_LB(n, Om*uno, Pe*uno); toc; tic
% expected execution time 0.2 sec
R_NA = rate_AWGN_NA_UB(n, Om*uno, Pe*uno); toc; tic
% % expected execution time 90.1 sec % <- needs function from SPECTRE
% R_ACH = shannon_ach2(n, Pe*uno, Om*uno)./n; toc; tic 

figure(1)
set(0,'defaulttextinterpreter','latex')
legend('interpreter','latex')
subplot(1,2,1)
plot(n, [C*ones(size(n));R_PPV;R_RCU;R_NA])
legend('Capacity','PPV','RCU','NA','Location','SouthEast')
% % <- having more plots needs functions from SPECTRE
% plot(n, [C*ones(size(n));R_SHA;R_PPV;R_RCU;R_NA;R_ACH]) 
% legend('Capacity','Shannon UB','PPV','RCU','NA','Shannon LB','Location','SouthEast')
axis([xlim R_NA(1) 1.05*C])
xlabel('packet length $n$')
ylabel('rate $R$ [bit/ch. use]')
grid


%% 2) RATE BOUNDS AT OM=20dB
disp(' ')
disp('RATE BOUNDS AT OM=20dB')

Om = 10^(20/10);
Pe = 10^-6;
C = rate_AWGN_NA_UB(inf, Om, Pe); tic
% % expected execution time 14.2 sec % <- needs function from SPECTRE
% R_SHA = converse(n, Pe*uno, Om*uno)./n; toc; tic
% expected execution time 2.5 sec
R_PPV = rate_AWGN_PPV_OnX_UB(n, Om*uno, Pe*uno, kappa); toc; tic
% expected execution time 2.9 sec
R_RCU = rate_AWGN_RCU_On2_LB(n, Om*uno, Pe*uno); toc; tic
% expected execution time 0.2 sec
R_NA = rate_AWGN_NA_UB(n, Om*uno, Pe*uno); toc; tic
% % expected execution time 794.0 sec % <- needs function from SPECTRE
% R_ACH = shannon_ach2(n, Pe*uno, Om*uno)./n; toc; tic

subplot(1,2,2)
plot(n, [C*ones(size(n));R_PPV;R_RCU;R_NA])
% % <- having more plots needs functions from SPECTRE
% plot(n, [C*ones(size(n));R_SHA;R_PPV;R_RCU;R_NA;R_ACH]) 
axis([xlim R_NA(1) 1.05*C])
xlabel('packet length $n$')
ylabel('rate $R$ [bit/ch. use]')
grid

%% PRINT RESULT
% print -dpdf fig4a.pdf 
