

%% 3) SPECTRAL EFFICIENCY CURVES
disp(' ')
disp('SPECTRAL EFFICIENCY CURVES')

Pe = 1e-5;
data = {... % n, om_PPV+NA+SHA, om_RCU
    {{2e2},{-9:15},{-2:15}},...
    {{1e3},{-15:15},{-10:15}},...
    {{1e4},{-24:15},{-20:15}},...
    {{1e5},{-32:15},{-30:15}},...
    {{1e6},{-32:15},{-32:15}}...
};
snr_dB = -32:15;

% % Shannon bound % <- needs function from SPECTRE
% % expected execution time .... TOO MUCH!!!!
rho_SHA = nan(length(data),length(snr_dB));
EbN0_SHA = nan(length(data),length(snr_dB)); tic
% for k=1:length(data)-2
%     n = data{k}{1}{1};
%     Om_dB = data{k}{2}{1};
%     uno = ones(size(Om_dB));
%     R_SHA = converse(n*uno, Pe*uno, 10.^(Om_dB/10))/n; 
%     rho_SHA(k,ismember(snr_dB,Om_dB)) = 2*R_SHA;
%     EbN0_SHA(k,ismember(snr_dB,Om_dB)) = Om_dB-10*log10(2*R_SHA);
% end; toc

% PPV bound 
% expected execution time 14.8 sec
rho_PPV = nan(length(data),length(snr_dB));
EbN0_PPV = nan(length(data),length(snr_dB)); tic
for k=1:length(data)
    n = data{k}{1}{1};
    Om_dB = data{k}{2}{1};
    uno = ones(size(Om_dB));
    R_PPV = rate_AWGN_PPV_OnX_UB(n*uno, 10.^(Om_dB/10), Pe*uno); 
    rho_PPV(k,ismember(snr_dB,Om_dB)) = 2*R_PPV;
    EbN0_PPV(k,ismember(snr_dB,Om_dB)) = Om_dB-10*log10(2*R_PPV);
end; toc

% RCU bound 
% expected execution time 18.8 sec
rho_RCU = nan(length(data),length(snr_dB));
EbN0_RCU = nan(length(data),length(snr_dB));  tic
for k=1:length(data)
    n = data{k}{1}{1};
    Om_dB = data{k}{3}{1};
    uno = ones(size(Om_dB));
    R_RCU = rate_AWGN_RCU_On2_LB(n*uno, 10.^(Om_dB/10), Pe*uno); 
    rho_RCU(k,ismember(snr_dB,Om_dB)) = 2*R_RCU;
    EbN0_RCU(k,ismember(snr_dB,Om_dB)) = Om_dB-10*log10(2*R_RCU);
end; toc

% NA bound 
% expected execution time 1.8 sec
rho_NA = nan(length(data),length(snr_dB));
EbN0_NA = nan(length(data),length(snr_dB));  tic
for k=1:length(data)
    n = data{k}{1}{1};
    Om_dB = data{k}{2}{1};
    uno = ones(size(Om_dB));
    R_NA = rate_AWGN_NA_UB(n*uno, 10.^(Om_dB/10), Pe*uno); 
    rho_NA(k,ismember(snr_dB,Om_dB)) = 2*R_NA;
    EbN0_NA(k,ismember(snr_dB,Om_dB)) = Om_dB-10*log10(2*R_NA);
end; toc



figure(1)
set(0,'defaulttextinterpreter','latex')
legend('interpreter','latex')
subplot(1,1,1)
semilogy(EbN0_PPV.',rho_PPV.')
hold on
semilogy(EbN0_RCU.',rho_RCU.','--')
semilogy(EbN0_NA.',rho_NA.','-.')
semilogy(EbN0_SHA.',rho_SHA.','k-')
hold off
xlabel('SNR $E_b/N_0$')
ylabel('spectral efficiency $\rho$ [bit/s/Hz]')
grid


%% PRINT RESULT
% print -dpdf fig4b.pdf 
