%% 4) PACKET ERROR RATE BOUNDS
disp(' ')
disp('PACKET ERROR RATE BOUNDS')

n = [5e2 1e3 2e3 5e3 1e4 1e5 1e6];
Pe = 10.^(-2:-0.5:-7);
uno = ones(size(Pe));
R = 1/2;
kappa = 2;  % use 2 or 3
tic

% NA bound 
% expected execution time 1.9 sec
for k = 1:length(n)    
    Om_NA(k,:) = 10*log10(error_BSC_NA_LB(n(k)*uno, R*uno, Pe));
end; toc; tic
% RCU bound 
% expected execution time 8.7 sec
for k = 1:length(n)    
    Om_RCU(k,:) = 10*log10(error_BSC_RCU_On2_UB(n(k)*uno, R*uno, Pe));
end; toc; tic
% PPV bound 
% expected execution time 8.5 sec (84 sec for kappa=40)
for k = 1:length(n)    
    Om_PPV(k,:) = 10*log10(error_BSC_PPV_OnX_LB(n(k)*uno, R*uno, Pe, kappa));
end; toc; tic

figure(1)
set(0,'defaulttextinterpreter','latex')
subplot(1,1,1)
semilogy(Om_NA,Pe,'--')
hold on
semilogy(Om_RCU,Pe,'-')
semilogy(Om_PPV,Pe)
hold off
xlabel('SNR $\Gamma$')
ylabel('error probability $P_e$')
grid


%% PRINT RESULT
% print -dpdf fig10b.pdf 
